diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index ddf3577e6..c90f2b9ba 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -12,7 +12,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -22,13 +21,19 @@ import org.joml.primitives.AABBdc;
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable, ISupportable {
+public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
+implements
+    IPaintable,
+    ISupportable,
+    BlockLogic.MatcherDataEquivalency.Masked
+{
     public static final int MASK_POWERED = 0b0000_0001;
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_POWERED;
     }
+
     public static final int MASK_SIDE = 0b0000_1110;
     private final @NotNull Class<T> triggerMobClass;
 
@@ -117,27 +122,39 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         Direction dir = sideFromMeta(meta).direction();
         boolean isSteppedOn = false;
         float pixel = 0.125F;
-        List<T> list = switch (sideFromMeta(meta)) {
+        AABBdc box = switch (sideFromMeta(meta)) {
             case BOTTOM ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z());
             case TOP ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z());
             case NORTH ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel)).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel)).translate(tilePos.x(), tilePos.y(), tilePos.z());
             case SOUTH ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1).translate(tilePos.x(), tilePos.y(), tilePos.z());
             case WEST ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z());
             default ->
-                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+                new AABBd(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z());
         };
 
+        List<T> list = world.getEntitiesWithinAABB(this.triggerMobClass, box);
         for (T t : list) {
             if (t.canInteract()) {
                 isSteppedOn = true;
                 break;
             }
         }
+
+        if (!isSteppedOn) {
+            List<Entity> vehicles = world.getEntitiesWithinAABB(Entity.class, box);
+            for (Entity vehicle : vehicles) {
+                Entity rider = vehicle.getPassenger();
+                if (this.triggerMobClass.isInstance(rider) && rider.canInteract()) {
+                    isSteppedOn = true;
+                    break;
+                }
+            }
+        }
         if (isSteppedOn && !isPressed) {
             world.setBlockData(tilePos, meta | MASK_POWERED);
             world.markBlockNeedsUpdate(tilePos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index cb789a486..94561ecb9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -23,7 +23,7 @@ import org.joml.primitives.AABBdc;
 import java.util.ArrayList;
 import java.util.List;
 
-public class BlockLogicRail extends BlockLogic implements ISupportable {
+public class BlockLogicRail extends BlockLogic implements ISupportable, BlockLogic.MatcherDataEquivalency {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_POWERED = 0b0000_1000;
     public final boolean isPowered;
@@ -39,20 +39,17 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
         final int dirMask = (this.isPowered) ? MASK_DIRECTION : MASK_DIRECTION | MASK_POWERED;
-        var railDir = RailDirection.getFromMeta(data & dirMask);
-        if (railDir.isStraight()) {
-            railDir = RailDirection.STRAIGHT_NS;
-        } else if (railDir.isSloped()) {
-            railDir = RailDirection.SLOPE_E;
-        } else if (railDir.isCurved()) {
-            assert !this.isPowered;
-            railDir = RailDirection.TURN_ES;
-        }
-        data &= ~MASK_DIRECTION;
-        data |= railDir.meta & dirMask;
-        return data;
+        if (this.isPowered && (thisData & MASK_POWERED) != (thatData & MASK_POWERED)) return false;
+
+        final var thisDir = RailDirection.getFromMeta(thisData & dirMask);;
+        final var thatDir = RailDirection.getFromMeta(thatData & dirMask);;
+
+        if (thisDir.isStraight()) return thatDir.isStraight();
+        if (thisDir.isCurved()) return thatDir.isCurved();
+        if (thisDir.isSloped()) return thatDir.isSloped();
+        return false;
     }
 
     public @NotNull RailDirection getRailDirection(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index 3accdf548..49d86f1cc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -23,7 +23,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicRepeater extends BlockLogic implements ISupportable {
+public class BlockLogicRepeater extends BlockLogic implements ISupportable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
     };
@@ -46,13 +46,8 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
     }
 
     @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicRepeater repeater && (this.isRepeaterPowered == repeater.isRepeaterPowered);
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_TICK_DELAY;
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_TICK_DELAY;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index ffd78e7c0..6e1a1bca6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -161,10 +161,4 @@ public class BlockLogicRope
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return new ItemStack[]{new ItemStack(Items.ROPE)};
     }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        // return data & ~MASK_ROPE_CONNECT;
-        return 0;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index f8ce3cecf..772126c65 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -16,11 +16,6 @@ public class BlockLogicRotatable extends BlockLogic {
         super(block, material);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
-    }
-
     public static @NotNull Direction getDirectionFromMeta(int meta) {
         return Direction.fromId(meta & MASK_DIRECTION);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
index 41ff6a93b..c3cd42236 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
@@ -20,7 +20,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicRubyglassCrystal extends BlockLogicTransparent {
+public class BlockLogicRubyglassCrystal extends BlockLogicTransparent implements BlockLogic.MatcherDataEquivalency {
 	public static final int BREAK_STAGES = 3;
 	private final @NotNull AABBd checkAABB = new AABBd();
 	public BlockLogicRubyglassCrystal(@NotNull Block<?> block) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index 204c5b483..8ec08268a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -3,7 +3,7 @@ package net.minecraft.core.block;
 import java.util.Random;
 
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.IBonemealable;
+// import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
@@ -13,7 +13,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements IBonemealable {
+public abstract class BlockLogicSaplingBase extends BlockLogicFlower /*implements IBonemealable*/ {
     public boolean canGrowOnSand = false;
 
     public BlockLogicSaplingBase(@NotNull Block<?> block) {
@@ -68,9 +68,4 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
     }
 
     public abstract void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random);
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return 0;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 55b145a16..8bcc92e0d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -23,7 +23,12 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicSign extends BlockLogic implements IPaintable {
+public class BlockLogicSign extends BlockLogic 
+implements 
+    IPaintable, 
+    BlockLogic.MatcherDataEquivalency.Masked,
+    BlockLogic.MatcherEntityEquivalency<TileEntitySign>
+{
     public static final int MASK_SIDE = 0b0000_1111;
     public static final int SIDE_NORTH = 2;
     public static final int SIDE_SOUTH = 3;
@@ -41,18 +46,24 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        if (((world.getBlockData(thisPos) ^ world.getBlockData(thatPos)) & ~MASK_SIDE) != 0) return false;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntitySign thisSign) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntitySign thatSign))
-            return false;
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_SIDE;
+    }
+
+    @Override
+    public @NotNull Class<TileEntitySign> getEntityEquivalencyClass() {
+        return TileEntitySign.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @NotNull TileEntitySign thisSign, @NotNull TileEntitySign thatSign
+    ) {
         if (thisSign.getPicture() != thatSign.getPicture()) return false;
 
         boolean isAllBlank = true;
-        assert thisSign.signText.length == 4 && thatSign.signText.length == 4;
-        for (int i = 0; i < 4; i++) {
+        assert thisSign.signText.length == thatSign.signText.length;
+        for (int i = 0; i < thisSign.signText.length; i++) {
             final boolean thisIsBlank, thatIsBlank; {
                 thisIsBlank = thisSign.signText[i].isEmpty() || thisSign.signText[i].isBlank();
                 thatIsBlank = thatSign.signText[i].isEmpty() || thatSign.signText[i].isBlank();
@@ -64,7 +75,7 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
 
         if (thisSign.getColor() != thatSign.getColor()) return false;
         if (thisSign.isGlowing() != thatSign.isGlowing()) return false;
-        for (int i = 0; i < 4; i++) {
+        for (int i = 0; i < thisSign.signText.length; i++) {
             if (!thisSign.signText[i].equals(thatSign.signText[i])) return false;
         }
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index cd85f0a6f..7d9e75bef 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -27,7 +27,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicSlab extends BlockLogic
+public class BlockLogicSlab extends BlockLogic implements BlockLogic.MatcherDataEquivalency
 {
     public @NotNull Block<?> modelBlock;
     public int modelBlockMetadata;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index f9b83120b..9c4df7e19 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -26,7 +26,7 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicSpikes extends BlockLogic
+public class BlockLogicSpikes extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked
 {
     public static final int MASK_POWERED = 0b0000_0001;
     public static final int MASK_DIRECTION = 0b0000_1110;
@@ -39,8 +39,8 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_POWERED;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index 9d86f24b0..599e968d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
@@ -16,82 +17,21 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.BoundingVolume;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3d;
+import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicStairs extends BlockLogic {
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_ROTATION_HORIZONTAL;
-    }
-
-    //    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
-//
-//    static
-//    {
-//        // EAST UP
-//        System.out.println("EAST UP");
-//        BoundingVolume vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 8, 0, 7, 15, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b0000, vol);
-//
-//        // WEST UP
-//        System.out.println("WEST UP");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(8, 8, 0, 15, 15, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b0001, vol);
-//
-//        // SOUTH UP
-//        System.out.println("SOUTH UP");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 8, 0, 15, 15, 7);
-//        vol.bake();
-//        selectionVolumes.put(0b0010, vol);
-//
-//        // NORTH UP
-//        System.out.println("NORTH UP");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 8, 8, 15, 15, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b0011, vol);
-//
-//        // EAST DOWN
-//        System.out.println("EAST DOWN");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 0, 0, 7, 7, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b1000, vol);
-//
-//        // WEST DOWN
-//        System.out.println("WEST DOWN");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(8, 0, 0, 15, 7, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b1001, vol);
-//
-//        // SOUTH DOWN
-//        System.out.println("SOUTH DOWN");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 0, 0, 15, 7, 7);
-//        vol.bake();
-//        selectionVolumes.put(0b1010, vol);
-//
-//        // NORTH DOWN
-//        System.out.println("NORTH DOWN");
-//        vol = BoundingVolume.newFilledVolume();
-//        vol.carveVolume(0, 0, 8, 15, 7, 15);
-//        vol.bake();
-//        selectionVolumes.put(0b1011, vol);
-//    }
+public class BlockLogicStairs extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MASK_ROTATION_HORIZONTAL = 0b0000_0011;
     public static final int MASK_ROTATION_VERTICAL = 0b0000_1000;
 
@@ -176,6 +116,44 @@ public class BlockLogicStairs extends BlockLogic {
         PartialSupport.INSTANCE.up().right(),    // South
     };
 
+    private static AABBd @NotNull [] stairLocalParts(int hRotation, float stepYOffset) {
+        return switch (hRotation) {
+            case H_ROTATION_WEST -> new AABBd[]{
+                    new AABBd(0.0, stepYOffset, 0.0, 0.5, 0.5 + stepYOffset, 1.0),
+                    new AABBd(0.5, 0.0, 0.0, 1.0, 1.0, 1.0)
+            };
+            case H_ROTATION_EAST -> new AABBd[]{
+                    new AABBd(0.0, 0.0, 0.0, 0.5, 1.0, 1.0),
+                    new AABBd(0.5, stepYOffset, 0.0, 1.0, 0.5 + stepYOffset, 1.0)
+            };
+            case H_ROTATION_NORTH -> new AABBd[]{
+                    new AABBd(0.0, stepYOffset, 0.0, 1.0, 0.5 + stepYOffset, 0.5),
+                    new AABBd(0.0, 0.0, 0.5, 1.0, 1.0, 1.0)
+            };
+            default -> new AABBd[]{
+                    new AABBd(0.0, 0.0, 0.0, 1.0, 1.0, 0.5),
+                    new AABBd(0.0, stepYOffset, 0.5, 1.0, 0.5 + stepYOffset, 1.0)
+            };
+        };
+    }
+
+    private static int stairOrientIndex(int meta) {
+        return (meta & MASK_ROTATION_HORIZONTAL) | ((meta & MASK_ROTATION_VERTICAL) >> 1);
+    }
+
+    private static BoundingVolume @NotNull [] bakeStairSelectionVolumes() {
+        BoundingVolume @NotNull [] out = new BoundingVolume[8];
+        for (int orient = 0; orient < 8; orient++) {
+            int h = orient & MASK_ROTATION_HORIZONTAL;
+            float stepY = (orient & 4) != 0 ? 0.5f : 0.0f;
+            AABBd[] parts = stairLocalParts(h, stepY);
+            out[orient] = BoundingVolume.bakeFromBlockSpaceAabbs(parts[0], parts[1]);
+        }
+        return out;
+    }
+
+    private static final BoundingVolume @NotNull [] STAIR_SELECTION_VOLUME = bakeStairSelectionVolumes();
+
     public @NotNull Block<?> modelBlock;
 
     public BlockLogicStairs(@NotNull Block<?> block, @NotNull Block<?> modelBlock) {
@@ -188,6 +166,11 @@ public class BlockLogicStairs extends BlockLogic {
         this.block.withHardness(this.modelBlock.blockHardness);
         this.block.withBlastResistance(this.modelBlock.blastResistance / 3F);
     }
+  
+    @Override
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_ROTATION_HORIZONTAL;
+    }
 
     @Override
     public @NotNull Material getMaterial() {
@@ -217,31 +200,48 @@ public class BlockLogicStairs extends BlockLogic {
 
     @Override
     public void getCollisionAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList) {
+        ArrayList<AABBdc> parts = new ArrayList<>(2);
+        collectStairPartAABBs(world, tilePos, parts);
+        for (AABBdc box : parts) {
+            addIntersectingBoundingBox(aabb, box, aabbList);
+        }
+    }
+
+    public void collectStairPartAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull List<@NotNull AABBdc> out) {
+        int meta = world.getBlockData(tilePos);
+        int hRotation = meta & MASK_ROTATION_HORIZONTAL;
+        float stepYOffset = (meta & MASK_ROTATION_VERTICAL) != 0 ? 0.5f : 0.0f;
+        double px = tilePos.x();
+        double py = tilePos.y();
+        double pz = tilePos.z();
+        for (AABBd part : stairLocalParts(hRotation, stepYOffset)) {
+            out.add(new AABBd(part).translate(px, py, pz));
+        }
+    }
+
+    @Override
+    public @Nullable BoundingVolume getBoundingVolume(@NotNull World world, @NotNull TilePosc tilePos) {
+        return STAIR_SELECTION_VOLUME[stairOrientIndex(world.getBlockData(tilePos))];
+    }
+
+    @Override
+    public @Nullable HitResult collisionRayTrace(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Vector3dc start, @NotNull Vector3dc end, boolean useSelectionAABB) {
         int meta = world.getBlockData(tilePos);
         int hRotation = meta & MASK_ROTATION_HORIZONTAL;
-        int vRotation = meta & MASK_ROTATION_VERTICAL;
-
-        float stepYOffset = vRotation != 0 ? 0.5f : 0.0f;
-
-        switch (hRotation) {
-            case H_ROTATION_WEST:
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                break;
-            case H_ROTATION_EAST:
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                break;
-            case H_ROTATION_NORTH:
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                break;
-            case H_ROTATION_SOUTH:
-            default:
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                break;
+        float stepYOffset = (meta & MASK_ROTATION_VERTICAL) != 0 ? 0.5f : 0.0f;
+        @Nullable HitResult closest = null;
+        double closestDistSq = Double.POSITIVE_INFINITY;
+        for (AABBd part : stairLocalParts(hRotation, stepYOffset)) {
+            @Nullable HitResult hit = traceRayAgainstLocalAabb(tilePos, start, end, part);
+            if (hit != null) {
+                double d2 = start.distanceSquared(hit.location);
+                if (d2 < closestDistSq) {
+                    closestDistSq = d2;
+                    closest = hit;
+                }
+            }
         }
+        return closest;
     }
 
     @Override
@@ -277,12 +277,6 @@ public class BlockLogicStairs extends BlockLogic {
     public int tickDelay() {
         return this.modelBlock.tickDelay();
     }
-//    @Override
-//    public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
-//    {
-//        int meta = world.getBlockMetadata(x, y, z);
-//        return selectionVolumes.getOrDefault(meta & 0x0F, null);
-//    }
 
     @Override
     public void onEntityInside(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity, @NotNull Vector3d velocityDirection) {
@@ -381,4 +375,106 @@ public class BlockLogicStairs extends BlockLogic {
     public @NotNull MaterialColor getMaterialColor() {
         return this.modelBlock.getMaterialColor();
     }
+
+    private static @Nullable HitResult traceRayAgainstLocalAabb(@NotNull TilePosc tilePos, @NotNull Vector3dc start, @NotNull Vector3dc end, @NotNull AABBdc bounds) {
+        double px = tilePos.x();
+        double py = tilePos.y();
+        double pz = tilePos.z();
+        Vector3d startInBlock = start.add(-px, -py, -pz, new Vector3d());
+        Vector3d endInBlock = end.add(-px, -py, -pz, new Vector3d());
+
+        @Nullable Vector3d minVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.minX(), new Vector3d());
+        @Nullable Vector3d maxVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.maxX(), new Vector3d());
+        @Nullable Vector3d minVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.minY(), new Vector3d());
+        @Nullable Vector3d maxVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.maxY(), new Vector3d());
+        @Nullable Vector3d minVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.minZ(), new Vector3d());
+        @Nullable Vector3d maxVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.maxZ(), new Vector3d());
+
+        if (!isVecInsideYzBounds(bounds, minVX)) minVX = null;
+        if (!isVecInsideYzBounds(bounds, maxVX)) maxVX = null;
+        if (!isVecInsideXzBounds(bounds, minVY)) minVY = null;
+        if (!isVecInsideXzBounds(bounds, maxVY)) maxVY = null;
+        if (!isVecInsideXyBounds(bounds, minVZ)) minVZ = null;
+        if (!isVecInsideXyBounds(bounds, maxVZ)) maxVZ = null;
+
+        @Nullable Vector3d clip = null;
+        @Nullable Side side = null;
+        double bestD2 = Double.POSITIVE_INFINITY;
+
+        if (minVX != null) {
+            double d2 = startInBlock.distanceSquared(minVX);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVX;
+                side = Side.WEST;
+            }
+        }
+        if (maxVX != null) {
+            double d2 = startInBlock.distanceSquared(maxVX);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = maxVX;
+                side = Side.EAST;
+            }
+        }
+        if (minVY != null) {
+            double d2 = startInBlock.distanceSquared(minVY);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVY;
+                side = Side.BOTTOM;
+            }
+        }
+        if (maxVY != null) {
+            double d2 = startInBlock.distanceSquared(maxVY);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = maxVY;
+                side = Side.TOP;
+            }
+        }
+        if (minVZ != null) {
+            double d2 = startInBlock.distanceSquared(minVZ);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = minVZ;
+                side = Side.NORTH;
+            }
+        }
+        if (maxVZ != null) {
+            double d2 = startInBlock.distanceSquared(maxVZ);
+            if (d2 < bestD2) {
+                bestD2 = d2;
+                clip = maxVZ;
+                side = Side.SOUTH;
+            }
+        }
+
+        if (clip == null) {
+            return null;
+        }
+
+        return new HitResult.Tile(tilePos, side, clip.add(px, py, pz, new Vector3d()));
+    }
+
+    private static boolean isVecInsideYzBounds(AABBdc bounds, @Nullable Vector3dc v) {
+        if (v == null) {
+            return false;
+        }
+        return v.y() >= bounds.minY() && v.y() <= bounds.maxY() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
+    }
+
+    private static boolean isVecInsideXzBounds(AABBdc bounds, @Nullable Vector3dc v) {
+        if (v == null) {
+            return false;
+        }
+        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
+    }
+
+    private static boolean isVecInsideXyBounds(AABBdc bounds, @Nullable Vector3dc v) {
+        if (v == null) {
+            return false;
+        }
+        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.y() >= bounds.minY() && v.y() <= bounds.maxY();
+    }
 }
